use async_trait::async_trait;
use reqwest::{Request, Response};
use reqwest_middleware::{Middleware, Next, Result};

pub const USER_AGENT: &str = "osrs-prometheus-exporter";

pub struct DefaultHeaderMiddleware {}

impl DefaultHeaderMiddleware {
    pub fn new() -> Self {
        DefaultHeaderMiddleware {}
    }
}

#[async_trait]
impl Middleware for DefaultHeaderMiddleware {
    async fn handle(
        &self,
        mut req: Request,
        extensions: &mut task_local_extensions::Extensions,
        next: Next<'_>,
    ) -> Result<Response> {
        req.headers_mut()
            .insert("User-Agent", USER_AGENT.parse().unwrap());

        next.run(req, extensions).await
    }
}